/* 
** Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
** smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
** Restrictions in GB_copyright.h.
** declare.c -- declare alliance, neutrality, war, the basic thing.
*/

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "races.h"
#include "buffers.h"
#include <signal.h>
#include <ctype.h>
int declare_racedata;

/* invite people to join your alliance block */
invite(Playernum, APcount, argn, args, mode)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
int mode;
{
racetype *alien;
int n;

 GetPlayer(args[1], &n, &alien);
   if (n == -1) {
	sprintf(buf,"No such player.\n");
		notify(Playernum, buf);
	return;
   }

if(n==Playernum) {
	notify(Playernum, "Not needed, you are the leader.\n");
	return;
	}

  free(Race);
  openracedata(&declare_racedata); 
  getrace(declare_racedata, &Race, Playernum);	
  close_file(declare_racedata);

if(mode) {
	setbit(Blocks[Playernum-1].invite, n);
	sprintf(buf, "%s [%d] has invited you to join %s\n", Race->name, 
			Playernum, Blocks[Playernum-1].name);
	notify(n, buf);
	push_message(TELEG_PLAYER_AUTO, n, buf);
	sprintf(buf, "%s has been invited to join %s\n", alien->name,
		Blocks[Playernum-1].name);
	notify(Playernum, buf);
    } else {
	clrbit(Blocks[Playernum-1].invite, n);
	sprintf(buf, "%s [%d] has retracted the invitation from %s\n", Race->name,
			Playernum, Blocks[Playernum-1].name);
	notify(n, buf);
	push_message(TELEG_PLAYER_AUTO, n, buf);
	sprintf(buf, "%s has been blackballed from %s\n", alien->name,
		Blocks[Playernum-1].name);
	notify(Playernum, buf);
}

Putblock(Blocks);
}

/* declare that you wish to be included in the alliance block */
pledge(Playernum, APcount, argn, args, mode)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
int mode;
{
racetype *alien;
int n;

  GetPlayer(args[1], &n, &alien);
   if (n == -1) {
	sprintf(buf,"No such player.\n");
		notify(Playernum, buf);
	return;
   }

if(n==Playernum) {
	notify(Playernum, "Not needed, you are the leader.\n");
	return;
	}

 if(mode) {
	setbit(Blocks[n-1].pledge, Playernum);
	sprintf(buf, "%s [%d] has pledged %s.\n", Race->name, 
			Playernum, Blocks[n-1].name);
	notify(n, buf);
	push_message(TELEG_PLAYER_AUTO, n, buf);
	sprintf(buf, "You have pledged allegiance to %s.\n",
                  Blocks[n-1].name);
	notify(Playernum, buf);
    } else {
	clrbit(Blocks[n-1].pledge, Playernum);
	sprintf(buf, "%s [%d] has quit %s.\n", Race->name,
			Playernum, Blocks[n-1].name);
	notify(n, buf);
	push_message(TELEG_PLAYER_AUTO, n, buf);
	sprintf(buf, "You have quit %s\n", Blocks[n-1].name);
	notify(Playernum, buf);
    }

Putblock(Blocks);
}

declare(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
char str[RNAMESIZE];
racetype *alien;
int n;

     /* look in sdata for APs first */
   if (Sdata.AP[Playernum] >= APcount)  /* enufAPs would print something */
	   deductAPs(Playernum,APcount, 0, 1);
     /* otherwise use current star */
   else if (Dir[Playernum-1].level==LEVEL_STAR || Dir[Playernum-1].level==LEVEL_PLAN) {
       if (enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount) )
	   deductAPs(Playernum,APcount, Dir[Playernum-1].snum, 0);
   } else {
	   sprintf(buf,"You don't have enough AP's (%d)\n",APcount);
		notify(Playernum, buf);
	return;
   }

  GetPlayer(args[1], &n, &alien);
   if (n == -1) {
	sprintf(buf,"No such player.\n");
		notify(Playernum, buf);
	return;
   }

  free(Race);
	openracedata(&declare_racedata); 
  getrace(declare_racedata, &Race, Playernum);	
	close_file(declare_racedata);

   switch (*args[2]) {
	case 'a':
		setbit(Race->allied, n);
		clrbit(Race->atwar, n);
		if (int_rand(0,100) >= 96)
			{
			sprintf(buf,"But would you want your sister to marry one?\n");
				notify(Playernum, buf);
		} else {
			sprintf(buf,"Good for you.\n");
				notify(Playernum, buf);
			}

		sprintf(buf," Player #%d (%s) has declared an alliance with you!\n",
			Playernum,Race->name);
			notify(n, buf);
		push_message(TELEG_PLAYER_AUTO, n, buf);
		break;
	case 'n':
		clrbit(Race->allied, n);
		clrbit(Race->atwar, n);
		sprintf(buf,"Done.\n");
			notify(Playernum, buf);

		sprintf(buf," Player #%d (%s) has declared neutrality with you!\n",Playernum,Race->name);
			notify(n, buf);
		push_message(TELEG_PLAYER_AUTO, n, buf);
		break;
	case 'w':
		setbit(Race->atwar, n);
		clrbit(Race->allied, n);
		if (int_rand(0,100) >= 96) {
			sprintf(buf, "Your enemies flaunt their secondary male reproductive glands in your\ngeneral direction.\n");
				notify(Playernum, buf);
		} else {
			sprintf(buf, "Give 'em hell!\n");
				notify(Playernum, buf);
			}

		sprintf(buf," Player #%d (%s) has declared war against you!\n",Playernum,Race->name);
			notify(n, buf);
		push_message(TELEG_PLAYER_AUTO, n, buf);

		break;
	default:
		return;
		break;
   }
/* They, of course, learn more about you */
alien->translate[Playernum-1] = MIN(alien->translate[Playernum-1]+30, 100);

openracedata(&declare_racedata);
putrace(declare_racedata, alien);
putrace(declare_racedata, Race);
close_file(declare_racedata);
}


