/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 * doship -- do one ship turn.
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "doturn.h"
#include "power.h"
#include "buffers.h"
#include <math.h>
#include <strings.h>


doship(shipno,ship)
int shipno;
shiptype *ship;
{
 int sh,sh2,j,shfdata;
 boolean trigger;

/*ship is active */
	ship->active = 1;

 if (ship->is_alive) {

/* for debugging */
	if(ship->popn > Max_crew(ship)) 
			ship->popn = Max_crew(ship);
	if(ship->destruct > Max_destruct(ship))
			ship->destruct = Max_destruct(ship);
	if(ship->fuel > (float)Max_fuel(ship))
			ship->fuel = (float)Max_fuel(ship);

/* compute the mass of the ship (there is a wierd bug that changes
   mass the wrong way) */
ship->mass = ship->popn*races[ship->owner-1]->mass + ship->resource*MASS_RESOURCE
  + ship->fuel*MASS_FUEL + ship->destruct*MASS_DESTRUCT
  + Mass(ship);

		/* repair radiation */
      if (ship->rad) {
	ship->active = 1;
			/* irradiated ships are immobile.. */
			/* kill off some people */
		/* check to see if ship is active */
		if(int_rand(1,100) <= ship->rad)
			ship->active = 0;
		ship->popn = round_rand(ship->popn * .80);
		if (ship->rad >= (int)REPAIR_RATE)
			ship->rad -= int_rand(0,(int)REPAIR_RATE);
		else
			ship->rad -= int_rand(0,ship->rad);
      } else
	   ship->active = 1;

      if(!ship->popn && Max_crew(ship) > 0
	 && !ship->is_docked) {
	ship->whatdest = LEVEL_UNIV;
      }

      if (ship->whatorbits>LEVEL_UNIV && Stars[ship->storbits]->nova_stage>0) {
		/* damage ships from supernovae */
	ship->damage += 50.0/Armor(ship);
	if (ship->damage >= 100) {
		kill_ship(ship);
		return;
	}
      }

   if(ship->active)
	Moveship(shipno, ship);



	if(ship->whatorbits != LEVEL_UNIV) {
/* printf("checking #%d\n",shipno); */
		StarsInhab[ship->storbits] = 1;
		setbit(Stars[ship->storbits]->inhabited, ship->owner);
		setbit(Stars[ship->storbits]->explored, ship->owner);
		if(ship->whatorbits == LEVEL_PLAN) {
			planets[ship->storbits][ship->pnumorbits]->info[ship->owner-1].explored = 1;
					}
		}
/* just making sure */	


		/* add ships, popn to total count to add AP's */
	Power[ship->owner-1].ships_owned++;
	Power[ship->owner-1].resource += ship->resource;
	Power[ship->owner-1].fuel += ship->fuel;
	Power[ship->owner-1].destruct += ship->destruct;
	Power[ship->owner-1].popn += ship->popn;

	if (ship->whatorbits==LEVEL_UNIV) {
		 Sdatanumships[ship->owner-1]++;
		 Sdatapopns[ship->owner] += ship->popn;
	} else {
		starnumships[ship->storbits][ship->owner-1]++; 
	         /* add popn of ships to popn */
	        starpopns[ship->storbits][ship->owner-1] += ship->popn;
		 /* set inhabited for ship */
		StarsInhab[ship->storbits] = 1;
		setbit(Stars[ship->storbits]->inhabited, ship->owner);
		setbit(Stars[ship->storbits]->explored, ship->owner);
	}




	if (ship->active) {

		/* bombard the planet */
	   if (can_bombard(ship) && ship->bombard
			&& ship->whatorbits==LEVEL_PLAN
			&& ship->whatdest==LEVEL_PLAN
			&& ship->deststar== ship->storbits
			&& ship->destpnum== ship->pnumorbits) {
				/* ship bombards planet */
		Stinfo[ship->storbits][ship->pnumorbits].inhab = 1;
	   }



	       /* repair ship by the amount of crew it has */
	       /* industrial complexes can repair (robot ships can't repair) */
	if (ship->damage && (ship->popn || ship->type==OTYPE_FACTORY)) {
             reg int drep,cost;
             reg float maxrep;
             maxrep = REPAIR_RATE;
	       /* stations repair for free, and ships docked with them */
	     if ((ship->type==STYPE_STATION || !Max_resource(ship)) || 
		(ship->is_docked && ship->whatdest==LEVEL_SHIP && 
		 ships[ship->destshipno]->type==STYPE_STATION))
	       {
		  cost = 0.0;
	     } else {
             maxrep *= (float)ship->popn / (float)Max_crew(ship);
             cost = 0.005 * maxrep * Cost(ship);
		}

             if (cost > ship->resource) 
              { 
	     drep = (int)maxrep * ship->resource / cost;
                ship->resource = 0; 
		} else { 
	      	ship->resource -= cost; 
		drep = (int)maxrep;
	      }

	     ship->mass -= cost * MASS_RESOURCE;

	     if (drep > ship->damage) ship->damage = 0;
                else 
		  ship->damage -= drep;
/*	     printf("rep = %d\n",drep); */
	}


     switch (ship->type) {

      case OTYPE_CANIST:
	   if (ship->whatorbits == LEVEL_PLAN && !ship->is_docked) { short *t;
	      if (--ship->object.number) {
		if ( Stinfo[ship->storbits][ship->pnumorbits].temp_add < -90 )
		  Stinfo[ship->storbits][ship->pnumorbits].temp_add = -100;
		else  
		  Stinfo[ship->storbits][ship->pnumorbits].temp_add -= 10;
	      } else {	/* timer expired; destroy canister */
		   reg int j=0;

		  kill_ship(ship);
		  sprintf(telegram_buf,"Notice from /%s/%s\n\n", 
			   Stars[ship->storbits]->name, 
			   Stars[ship->storbits]->pnames[ship->pnumorbits]);
		  sprintf(buf, "Canister of dust previously covering this planet has dissipated.\n");
			str_cat(telegram_buf, buf);
		  for (j=1; j<=Num_races; j++)
		       if (planets[ship->storbits][ship->pnumorbits]->info[j-1].numsectsowned) 
				push_message(TELEG_PLAYER_AUTO, j, telegram_buf);
	      }
	   }
	   break;

      case STYPE_MINE:
		/* check around and see if we should explode. */
	   if (ship->on) {
		int rad=0; int dam=0; double xd,yd,range; int p;
	     if (ship->whatorbits==LEVEL_STAR)
	     	sh = Stars[ship->storbits]->ships;
	     else if (ship->whatorbits==LEVEL_PLAN)
		sh = planets[ship->storbits][ship->pnumorbits]->ships;
	     else
		sh = Sdata.ships;
	     sh2 = sh;
	      /* traverse the list, look for ships that 
			are closer than the trigger radius... */
/*printf("found mine  sh = %d rad = %d\n",sh,rad);*/
	       while (sh && !rad) {
		xd = ships[sh]->xpos - ship->xpos;
		yd = ships[sh]->ypos - ship->ypos;
		range = sqrt(xd*xd + yd*yd);
		if ( !isset(races[ship->owner-1]->allied, ships[sh]->owner) && 
		   (ships[sh]->owner != ship->owner) && 
		   ( range <= (float)ship->object.number) )
			 rad = 1;
		else {
			 sh = ships[sh]->nextship;
		       }
	     }

/*printf("rad = %d\n",rad);*/
	     if (rad) {
		  char telegram_not[1000];
		kill_ship(ship);
		sprintf(telegram_buf, "BULLETIN!\n mine #%d triggered at %s\n",
				shipno,prin_ship_orbits(ship));

		/* I have made the blast radius equal to the trigger radius.*/
		/* -R. */

		sh = sh2 ;   /* Make sh start from beginning of the list */
		while (sh) {

			xd = ships[sh]->xpos - ship->xpos;
			yd = ships[sh]->ypos - ship->ypos;
			range = sqrt(xd*xd + yd*yd);
			trigger = (int_rand(1,100) 
				<= 2 * Size(ships[sh]));

		   if (range <= ship->object.number && trigger) {

		     if (!ship->mine.mode) {
		        int totalrad;
			 /* radiation mine */

		        rad = round_rand(ship->destruct * 
			  (1./(float)Size(ships[sh])) * 
			  (800/(range + 1.)) );

			rad = MIN(int_rand(0,rad),100);

			totalrad = ships[sh]->rad + rad;
			if (totalrad > 100 ) totalrad = 100;
			        ships[sh]->rad = totalrad;

			if (rad) {
			     sprintf(telegram_not, "BULLETIN!\n %s #%d irradiated by mine #%d\n", Shipnames[ships[sh]->type], sh, shipno);
			     sprintf(buf," at %s - dosage %d%%",prin_ship_orbits(ships[sh]), rad);
			str_cat(telegram_not, buf);
	push_message(TELEG_PLAYER_AUTO, ships[sh]->owner, telegram_not);
			     sprintf(buf,"%s #%d [%d] received %d%% dosage\n",
				Shipnames[ships[sh]->type], sh, 
					ships[sh]->owner, rad);
		str_cat(telegram_buf, buf);
			}

		      } else {
			int totaldam;	
			 /* explosive mine */
		        rad = round_rand(ship->destruct * 
			  (1./(float)Size(ships[sh])) * 
			  (800.0/(range + 1.)) );

			dam = MIN(100,int_rand(0,rad));
			totaldam = ships[sh]->damage+dam;
			if (totaldam > 100 ) totaldam = 100;
			if (dam>0) {
			   ships[sh]->damage = totaldam;
			   sprintf(telegram_not, "BULLETIN!\n %s #%d damaged by mine #%d\n",
					 Shipnames[ships[sh]->type], sh, shipno);
			   sprintf(buf," at %s - %d %% damage", prin_ship_orbits(ship), dam);
					str_cat(telegram_not, buf);
			   sprintf(buf,"%s #%d [%d] received %d%% damage\n",
				Shipnames[ships[sh]->type], sh, 
				ships[sh]->owner, rad);
				str_cat(telegram_buf, buf);
			   if (ships[sh]->damage >= 100) {
				kill_ship(ships[sh]);
				sprintf(buf, " %s #%d DESTROYED",Shipnames[ships[sh]->type],sh);
					str_cat(telegram_not, buf);
				sprintf(buf,"\t--DESTROYED\n");
					str_cat(telegram_buf, buf);
			   }
	push_message(TELEG_PLAYER_AUTO, ships[sh]->owner, telegram_not);
			}
		       }

		     }

		     sh = ships[sh]->nextship;
		}
	     }
	push_message(TELEG_PLAYER_AUTO, ship->owner, telegram_buf); 
	   }
	   break;

      case STYPE_MIRROR:
	  switch (ship->aimed_at.level) {
	   case LEVEL_SHIP: /* ship aimed at is a legal ship now */
			  /* if in the same system */
	    if ( (ship->whatorbits==LEVEL_STAR || ship->whatorbits==LEVEL_PLAN)
		   && (ships[ship->aimed_at.shipno]!=NULL)
		   && (ships[ship->aimed_at.shipno]->whatorbits==LEVEL_STAR ||
			ships[ship->aimed_at.shipno]->whatorbits==LEVEL_PLAN)
		   && ship->storbits == ships[ship->aimed_at.shipno]->storbits 
		   && ships[ship->aimed_at.shipno]->is_alive ) {
			    shiptype *s;
			      reg int i;
			      float range;
				s = ships[ship->aimed_at.shipno];
		  range = sqrt(Distsq(ship->xpos, ship->ypos,s->xpos,s->ypos));
		  i = int_rand(0,round_rand((2./((float)Size(s)))
		    *(float)ship->aimed_at.intensity/(range/PLORBITSIZE+1.0)));
	  sprintf(telegram_buf, "Space Mirror #%d %s [owner %d] aimed at ",
		  shipno, ship->name, ship->owner);
		str_cat(telegram_buf, buf);
	  sprintf(buf, "%s #%d %s [owner %d] !\n",Shipnames[s->type],
		  ship->aimed_at.shipno, s->name, s->owner);
		str_cat(telegram_buf, buf);
				s->damage += i;
			    if(i) {
	  sprintf(buf, "\n%d%% damage done.\n",i);
		str_cat(telegram_buf, buf); 
			    }
				if (s->damage >= 100) {
	  sprintf(buf, "%s #%d DESTROYED!!!\n",Shipnames[s->type],
		  ship->aimed_at.shipno);
					kill_ship(s);
				      }

 push_message(TELEG_PLAYER_AUTO, s->owner, telegram_buf);
 push_message(TELEG_PLAYER_AUTO, ship->owner, telegram_buf);
			}
		break;
	   case LEVEL_PLAN: { reg short *t; 
			      reg int i;
			      float range;
		  range = sqrt(Distsq(ship->xpos, ship->ypos,
			Stars[ship->storbits]->xpos
		       +planets[ship->storbits][ship->pnumorbits]->xpos,
			Stars[ship->storbits]->ypos
		       +planets[ship->storbits][ship->pnumorbits]->ypos));

		  if ( range > PLORBITSIZE ) 
			  i = PLORBITSIZE * ship->aimed_at.intensity/range;
		  else
			  i = ship->aimed_at.intensity;

		i = round_rand(.01*(100.0-(float)ship->damage)*(float)i);
		  Stinfo[ship->storbits][ship->aimed_at.pnum].temp_add += i;

		} break;

	   case LEVEL_STAR: { float range;
		  /* have to be in the same system as the star; otherwise
		      it's not too fair.. */
		if (ship->aimed_at.snum>0 && 
			ship->aimed_at.snum < Sdata.numstars &&
			ship->whatorbits > LEVEL_UNIV &&
			ship->aimed_at.snum == ship->storbits)
		    Stars[ship->aimed_at.snum]->stability += random()&01;
		} break;
	   case LEVEL_UNIV:
		break;
	}
	break;
     case STYPE_GOD:
		/* gods have infinite power.... heh heh heh */
	ship->fuel = Max_fuel(ship);
	ship->popn = Max_crew(ship);
	ship->destruct = Max_destruct(ship);
	ship->resource = Max_resource(ship);
	break;

     case OTYPE_AP:	/* atmospheric processor */
		/* if landed on planet, change conditions to be like race */
	if (ship->is_docked && ship->whatdest==LEVEL_PLAN && ship->on) {
		int j,d,a;planettype *p;
		p = planets[ship->storbits][ship->pnumorbits];
		if (ship->fuel >= 3.0) {
			ship->fuel -= 3.0;
			for (j=RTEMP+1; j<=OTHER; j++) {
				if ( (d = races[ship->owner-1]->conditions[j] - 
				      p->conditions[j]) != 0) {
	   
				  a = sgn(d)*int_rand(-1,
           round_rand(MIN(3,d*sgn(d))
	   *(float)ship->popn/(float)Shipdata[OTYPE_AP][ABIL_MAXCREW]));
				  if (p->conditions[j] + a < 0)
					p->conditions[j] = 0;
				  else if (p->conditions[j] + a > 100)
					p->conditions[j] = 100;
				  else p->conditions[j] += a;
				}
			}
		} else if (!ship->notified) {
			ship->notified = 1;
			msg_OOF(ship, shipno, telegram_buf);
		}
	}
	break;

     case OTYPE_VN:	/* Von Neumann machine */
	do_VN(ship,shipno);
	break;

     case OTYPE_BERS:	/* Berserker */
		/* (turn done in doplanet() ) */
	break;

     case STYPE_ASS:
	 /* "indimidate" the planet below, for enslavement purposes. */
	if (ship->whatorbits==LEVEL_PLAN)
		Stinfo[ship->storbits][ship->pnumorbits].intimidated = 1;
	break;

     case OTYPE_OMCL:
	 /* orbital mind control laser */
	if (ship->aimed_at.level==LEVEL_PLAN && ship->on &&
	    ship->speed==1) {
		planets[ship->aimed_at.snum][ship->aimed_at.pnum]
			->is_sheep = 1;
	}
	break;

     case STYPE_HABITAT:{ reg int add;
	 /* habitats multiply some resources inside them. */
	add = ship->resource *
		((float)ship->popn / Shipdata[STYPE_HABITAT][ABIL_MAXCREW]) 
	         * (100 - ship->damage) * 0.0005;
	if (ship->resource+add > Shipdata[STYPE_HABITAT][ABIL_CARGO])
		add = Shipdata[STYPE_HABITAT][ABIL_CARGO] - ship->resource;
	ship->resource += add;
	ship->mass += add * MASS_RESOURCE;
	add = ship->popn * races[ship->owner-1]->birthrate * 
		(100 - ship->damage) * 0.002;
	if (ship->popn+add > Shipdata[STYPE_HABITAT][ABIL_MAXCREW])
		add = Shipdata[STYPE_HABITAT][ABIL_MAXCREW] - ship->popn;
	ship->popn += add;
	ship->mass += add * races[ship->owner-1]->mass;
	} break;

     case STYPE_POD:
      if (ship->notified) {
    	/* we just arrived at this system -- explode */
    	/* or, we are floating in space with no fuel -- just die */
    	reg int i,f;

	f = -1;
    	kill_ship(ship);
    	if (ship->whatorbits==LEVEL_STAR) {

		  i = int_rand(0,Stars[ship->storbits]->numplanets - 1);

		     if(int_rand(1,4)==1)
    			f = i;

    	  sprintf(telegram_buf, "Bulletin\n\nSpore pod #%d has warmed and exploded.\n",shipno);
     	  if (f != -1) {
    		sprintf(buf,"A spore has landed on planet %s.\n",Stars[ship->storbits]->pnames[f]);
    		Stinfo[ship->storbits][f].Thing_add = ship->owner;
    			/* so doplanet does not pass over it */
		StarsInhab[ship->storbits] = 1;
    		setbit(Stars[ship->storbits]->inhabited,ship->owner);
    		setbit(Stars[ship->storbits]->explored, ship->owner);
    		planets[ship->storbits][f]->info[ship->owner-1].explored = 1;
    	  } else {
    		sprintf(buf,"No spores have survived.\n");
    	  }
			str_cat(telegram_buf, buf);
	push_message(TELEG_PLAYER_AUTO, ship->owner, telegram_buf); 
    	  sprintf(telegram_buf,"BULLETIN!\n\n A spore pod has exploded in system /%s.\n",
			Stars[ship->storbits]->name);
    	  sprintf(buf, "Spores may have drifted to planets here.\n");
			str_cat(telegram_buf, buf);
    	  for (i=1; i<=Num_races; i++)
    		if (i!=ship->owner && isset(Stars[ship->storbits]->inhabited,i))
	push_message(TELEG_PLAYER_AUTO, i, telegram_buf);

   	}
     }
     break;

     default:
	break;
    }

   }

 } else if (!ship->is_alive && !ship->notified) {
	 /* ship is dead -- add to shipfree file, remove from all lists. */
	 /* if notified, this means it's already been deleted and written. */
/*	printf("destroyed ship #%d\n",shipno);*/
	if (ship->type == OTYPE_VN || ship->type==OTYPE_BERS) {

		 /* add ship to VN shit list */

		if (ship->object.number2>0 && ship->object.number2<=Num_races 
		    && ship->object.number2 != ship->owner) {
		 Sdata.VN_hitlist[ship->object.number2-1] ++;

		  /* keep track of where these VN's were shot up */

		 if (Sdata.VN_index1[ship->object.number2]== 255)
			 /* there's no star in the first index */
			Sdata.VN_index1[ship->object.number2] = ship->storbits;
		 else if (Sdata.VN_index2[ship->object.number2]== 255)
			 /* there's no star in the second index */
			Sdata.VN_index2[ship->object.number2] = ship->storbits;
		 else {
			 /* pick an index to supplant */
		    if (random()&01)
			Sdata.VN_index1[ship->object.number2] = ship->storbits;
		    else
			Sdata.VN_index2[ship->object.number2] = ship->storbits;
		 }
		 printf("\t-- added %d ships, player %d\n",
				ship->object.number, ship->object.number2);
		}
	}
	ship->notified = 1;
	makeshipdead(shipno);
 }

}
