/* 
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * makeuniv.c -- make data files for the game
 */

#include "GB_copyright.h"
#define EXTERN
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "power.h"	/* (for power) */
#include <math.h>


FILE *fopen();
planettype Makeplanet();
char *Numbers[] = { "1","2","3","4","5","6","7","8","9","10","11",
		      "12","13","14","15" };	/* for planet naming*/

main(argc,argv)
int argc;
char *argv[];
{
FILE *teledata,*racedata,*stardata,*planetdata,*sectordata,*shipdata;
planettype planet;
startype *Star;
int star,e,e2,type,lowp,hip, roll, temperature;
register int i,y,x;
char str[200];
float att,xspeed[NUMSTARS],yspeed[NUMSTARS], dist, dummy;
float xpos, ypos;

 srandom(getpid());

 Bzero(Sdata);
 printf("# of stars(1-%d):",NUMSTARS-1);
 scanf("%d",&(Sdata.numstars));
 printf("low # of planets (1-%d):",MAXPLANETS);
 scanf("%d",&lowp);
 printf("hi # of planets (%d-%d):",lowp,MAXPLANETS);
 scanf("%d",&hip);
 getchr();

 sprintf(str, "/bin/mkdir %s", DATADIR );
 system(str);

 if ( (planetdata = fopen(PLANETDATAFL,"w+"))==NULL) {
	printf("unable to open %s\n",PLANETDATAFL);
	exit(-1);
 }
 if ( (sectordata = fopen(SECTORDATAFL,"w+")) == NULL ) {
	printf("unable to open %s\n",SECTORDATAFL);
	exit(-1);
 }

  /* get names, positions of stars first */
 for (star=0; star<Sdata.numstars; star++) {
 	Stars[star]=(startype *)malloc(sizeof(startype));
 	Bzero(*Stars[star]);
 	Star = Stars[star];
 	Star->numplanets=int_rand(lowp, int_rand(lowp, hip));
	Star->temperature=int_rand(0, 4)+int_rand(1, 5);
	    /* heat of the star */
 	Star->gravity = int_rand(10000,100000) / 100.0;
 	printf("[%d] name of star (%d planets):",star, Star->numplanets);
	for (i=0; i<NAMESIZE-4; i++)
	   putchr('.');
	for (i=0; i<NAMESIZE-4; i++)
	   putchr('\010');		/* ^H */
 	scanf("%14[^\n]",Star->name);
	  getchr();
 	Star->xpos=(float)int_rand(-UNIVSIZE,UNIVSIZE);
	xspeed[star] = 0;
 	Star->ypos=(float)int_rand(-UNIVSIZE,UNIVSIZE);
	yspeed[star] = 0; 
}

 for (star=0; star<Sdata.numstars; star++) {

  Star = Stars[star];

  for (i=0; i<Star->numplanets; i++)  {
	sprintf(Star->pnames[i],"%s",Numbers[i]);

	dist = -1.0;
	while (dist >= SYSTEMSIZE || dist <= 100.0) {
	  xpos=(float)int_rand(-SYSTEMSIZE,SYSTEMSIZE);
	  ypos=(float)int_rand(-SYSTEMSIZE,SYSTEMSIZE);
	  dist = sqrt(Distsq(xpos, ypos, 0, 0));	
	  }
		roll=int_rand(0,100);
	temperature = Temperature(dist, Star->temperature);

	if(temperature > 200) {
		if(roll<=25)
			type = TYPE_AIRLESS;
		else
			type = TYPE_ASTEROID;
	} else if(temperature > 100 && temperature <=200) {
		if(roll<=50)
			type = TYPE_ASTEROID;
		else
			type = TYPE_AIRLESS;
	} else if(temperature > 30 && temperature <= 100) {
		if(roll<=25)
			type = TYPE_ASTEROID;
		else if(roll > 25 && roll <=50)
			type = TYPE_AIRLESS;
		else if(roll > 50 && roll <=75)
			type = TYPE_EARTH;
		else
			type = TYPE_WATER;
	} else if(temperature > -10 && temperature <= 30) {
		if(roll <=25)
			type = TYPE_ASTEROID;
		else if(roll > 25 && roll <=50)
			type = TYPE_AIRLESS;
		else if(roll > 50 && roll <=75)
			type = TYPE_EARTH;
		else
			type = TYPE_WATER;
	} else if(temperature > -50 && temperature <= -10) {
		if(roll <=25)
			type = TYPE_ASTEROID;
		else if(roll>25 && roll <=50)
			type = TYPE_AIRLESS;
		else if(roll>50 && roll <=75)
			type = TYPE_ICEBALL;
		else
			type = TYPE_EARTH;
	} else if(temperature <= -50) {
		if(roll<=25)
			type = TYPE_ASTEROID;
		else if(roll>25 && roll <=50)
			type = TYPE_AIRLESS;
		else if(roll >50 && roll <=75)
			type = TYPE_ICEBALL;
		else
			type = TYPE_GASGIANT;
	}	


	planet = Makeplanet(dist, Star->temperature, type);
	planet.xpos = xpos;
	planet.ypos = ypos;
	
 	
	if (argc==2 && (argv[1][1]=='v' || argv[1][1]=='a'))
		printf("planet %s is type %u\n",Star->pnames[i],planet.type);

	if (argc==2 && argv[1][1]=='v') {
	  printf("at %f,%f relative to %s.\n",planet.xpos,planet.ypos,Star->name);
	  printf("sect map(%dx%d):\n",planet.Maxx,planet.Maxy);
	  for (y=0; y<planet.Maxy; y++) {
	   for (x=0; x<planet.Maxx; x++) {
	      switch (Sector(planet,x,y).des) {
		case DES_LAND: putchr(CHAR_LAND); break;
		case DES_SEA: putchr(CHAR_SEA); break;
		case DES_MOUNT: putchr(CHAR_MOUNT); break;
		case DES_ICE: putchr(CHAR_ICE); break;
		case DES_GAS: putchr(CHAR_GAS); break;
		default: putchr('?'); break;
	      }
	   }
	   putchr('\n');
	  }
	}
    	Star->planetpos[i] = (int)ftell(planetdata); 
				/* posn of file-last write*/
    	planet.sectormappos = (int)ftell(sectordata); /* sector map pos */
    	fwrite(&planet,sizeof(planettype),1,planetdata); /* write planet */
	 /* write each sector row */
     	for (y=0; y < planet.Maxy; y++)
       	  	fwrite( &Sector(planet,0,y), 
				sizeof(sectortype),planet.Maxx,sectordata);
  }
 }
 fchmod(planetdata,00660);	/* change data files to group readwrite */
 fclose(planetdata);
 fchmod(sectordata,00660);
 fclose(sectordata);

  /* get rid of this */
 if ((stardata = fopen("data.starB","w+"))==NULL) {
	printf(" unable to open %s\n","data.starB");
	exit(-1);
 }
 fwrite(&(Sdata),sizeof(Sdata),1,stardata);
 for (star=0; star<Sdata.numstars; star++) {
   fwrite(Stars[star],sizeof(startype),1,stardata);
 }
 fchmod(stardata,00660);
 fclose(stardata);

  /* try to (more or less) evenly space the stars */
 for (i=0; i<CREAT_UNIV_ITERAT; i++)
   for (star=0; star<Sdata.numstars; star++) {
     for (x=0; x<Sdata.numstars; x++)	/* star2 */
	if (x!=star) {
		/* find inverse of distance squared */
	   att = 10*UNIVSIZE / Distsq(Stars[star]->xpos, Stars[star]->ypos, Stars[x]->xpos, Stars[x]->ypos);
	   xspeed[star] += att * (Stars[star]->xpos - Stars[x]->xpos);
	   if (Stars[star]->xpos>UNIVSIZE || Stars[star]->xpos< -UNIVSIZE)
		xspeed[star] *= -1;
	   yspeed[star] += att * (Stars[star]->ypos - Stars[x]->ypos);
	   if (Stars[star]->ypos>UNIVSIZE || Stars[star]->ypos< -UNIVSIZE)
		yspeed[star] *= -1;
        }
    Stars[star]->xpos += xspeed[star];
    Stars[star]->ypos += yspeed[star];
    }

 if ((stardata = fopen(STARDATAFL,"w+"))==NULL) {
	printf(" unable to open %s\n",STARDATAFL);
	exit(-1);
 }
 fwrite(&(Sdata),sizeof(Sdata),1,stardata);
 for (star=0; star<Sdata.numstars; star++) {
   fwrite(Stars[star],sizeof(startype),1,stardata);
 }
 fchmod(stardata,00660);
 fclose(stardata);

 { shiptype s;
 if ((shipdata = fopen(SHIPDATAFL,"w+"))==NULL) {
	printf(" unable to open %s\n",SHIPDATAFL);
	exit(-1);
 }
 fchmod(shipdata,00660);
 fclose(shipdata);
 }

 { short s=1;
 if ((shipdata = fopen(SHIPFREEDATAFL,"w+"))==NULL) {
	printf(" unable to open %s\n",SHIPFREEDATAFL);
	exit(-1);
 }
 fchmod(shipdata,00660);
 fclose(shipdata);	/* touch ship free position file */
 }

 if ((shipdata = fopen(PLAYERDATAFL,"w+"))==NULL) {
	printf(" unable to open %s\n",PLAYERDATAFL);
	exit(-1);
 }
 fchmod(shipdata,00660);
 fclose(shipdata);	/* touch player file */

 if ((racedata = fopen(RACEDATAFL,"w+"))==NULL) {
	printf(" unable to open %s\n",RACEDATAFL);
	exit(-1);
 }
 fchmod(racedata,00660);
 fclose(racedata);	/* touch race data file */

 { 
 struct power p[MAXPLAYERS];
 bzero((char *)p, sizeof(p));
 if ((racedata = fopen(POWFL,"w+"))==NULL) {
	printf(" unable to open %s\n",POWFL);
	exit(-1);
 }
 fwrite(p,sizeof(p),1,racedata);
 fchmod(racedata,00660);
 fclose(racedata);	/* touch power data file */
 }

 { 
 struct block p[MAXPLAYERS];
 bzero((char *)p, sizeof(p));
 if ((racedata = fopen(BLOCKDATAFL,"w+"))==NULL) {
	printf(" unable to open %s\n",BLOCKDATAFL);
	exit(-1);
 }
 fwrite(p,sizeof(p),1,racedata);
 fchmod(racedata,00660);
 fclose(racedata);	/* touch block data file */
 }

 sprintf(str, "/bin/mkdir %s", TELEGRAMDIR );
 system(str);
 chmod(TELEGRAMDIR, 00770);

	/* make telegram files for each player */
 for (i=1; i<=MAXPLAYERS; i++) {
 	sprintf(str, "%s.%d", TELEGRAMFL, i );
 	if ((teledata = fopen(str, "w+"))==NULL) {
		printf(" unable to open %s\n",str);
	} else {
		fchmod(teledata,00660);
		fclose(teledata);
	}
   }
}
