/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB.c, enroll.dat.
 * Restrictions in GB.c.
 *  tweakable constants & other things -- changing the following may cause GB 
 *	to freak if
 *	the functions using them are not recompiled so be careful.
 */

 

#define DEFAULT_UPDATE_TIME 4		/* update time (hours) */


#define NO_EXCL 0
#define EXCL 1		/* tells fileread() whether to apply an exclusive
			   file lock on the data file being read.  (flock only)
			*/
#define LOGIN_NAME_SIZE 13

#define NUM_TIMES_TO_WAIT_FOR_LOCK 200
#define NEUTRAL_FD 1000

#define MAXCOMMSTRSIZE 250
#define COMMANDSIZE 42
#define MAXARGS 256

#define CHAR_CURR_SCOPE ':'	/* for getplace */

#define RTEMP 	  0		/* regular temp for planet */
#define TEMP 	  1		/* temperature */
#define METHANE   2		/* %age of gases for terraforming */
#define OXYGEN 	  3
#define CO2 	  4
#define HYDROGEN  5
#define NITROGEN  6
#define SULFUR 	  7
#define HELIUM 	  8
#define OTHER 	  9
#define TOXIC	 10

#define CHAR_LAND 		'*'
#define CHAR_SEA 		'.'
#define CHAR_MOUNT 		'^'
#define CHAR_DIFFOWNED 		'?'
#define CHAR_PLATED 		'o'
#define CHAR_WASTELAND 		'%'
#define CHAR_GAS 		'~'
#define CHAR_CLOAKED 		' '
#define CHAR_ICE		'#'

#define NAMESIZE 18
#define RNAMESIZE 35
#define PLACENAMESIZE (NAMESIZE + NAMESIZE + 13)
#define NUMSTARS 100
#define MAXPLANETS 10
#define BITS_MAXPLANETS 4	/* # bits required to represent MAXPLANETS*/
/*#define MAXMOONS 3*/


#define MAX_X 45	/* top range for planet */
#define MAX_Y 19
#define RATIOXY 3.70		/* map ratio between x and y */
				/* ranges of map sizes (x usually ) */


#define UNIVSIZE	100000
#define SYSTEMSIZE	2000
#define PLORBITSIZE	50


#define AUTO_TELEG_SIZE		2000
#define UNTRANS_MSG		"[ ? ]"
/*#define TELEG_TRANS_APCOST	1*/
#define TELEG_TRANS_RPCOST	5
#define TELEG_TRANS_AMT		0.45
#define TELEG_LETTERS		7
#define TELEG_PLAYER_AUTO	(-2)
#define TELEG_MAX_AUTO		7   /* when changing, alter field in plinfo */
#define TELEG_DELIM		'~'
#define TELEG_NDELIM		"%[^~]"

#define MASS_FUEL 	0.05
#define MASS_RESOURCE 	0.1
#define MASS_DESTRUCT 	0.15

#define VN_RES_TAKE	0.5	/* amt of resource of a sector the VN's take */

#define LAUNCH_GRAV_MASS_FACTOR 0.18	/* fuel use modifier for taking off */
#define LAND_GRAV_MASS_FACTOR 0.29

#define FUEL_GAS_ADD 5.0	/* amt of fuel to add to ea ships tanks */
#define FUEL_GAS_ADD_TANKER 10.0
#define FUEL_GAS_ADD_HABITAT 20.0
#define FUEL_GAS_ADD_STATION 20.0
#define FUEL_USE 0.02		/* fuel use per ship mass pt. per speed
				   factor */

#define REPAIR_RATE 25.0	/* rate at which ships get repaired */


#define CREAT_UNIV_ITERAT 10	/* iterations for star movement */


#define GRAV_FACTOR 0.0025	/* not sure as to what this should be*/


#define FACTOR_FERT_SUPPORT 25
			       /* # of people/fert pt sector supports*/
#define EFF_PROD 		0.20		/* production of effcncy/pop*/
#define RESOURCE_PRODUCTION 	0.00008 /* adjust these to change prod*/
#define FUEL_PRODUCTION		0.00004

#define DEST_PRODUCTION 	0.00008
#define POPN_PROD		0.3

#define HYPER_DRIVE_READY_CHARGE 1
#define HYPER_DRIVE_FUEL_USE 1.0
#define HYPER_DIST_FACTOR 20000.

#define TECH_INVEST		0.10	/* invest factor */

#define MOB_COST		0.010   /* mobiliz.c, doplanet.c cost/mob points*/
/*#define RESOURCE_DEPLETION 	0.015 */
#define RESOURCE_DEPLETION      0.0
#define FACTOR_MOBPROD 		0.06	/* mobilization production/person */

#define FUEL_COST_TERRA		3	/* cost to terraform */

#define PLAN_FIRE_LIM		20	/* max fire strength from planets */

#define TECH_SEE_STABILITY 15	/* min tech to see star stability */

#define TECH_EXPLORE 	   10	/* min tech to see your whole planet */

#define ENVIR_DAMAGE_TOX	70
	/* min tox to damage planet */

#define PLANETGRAVCONST 	0.05
#define SYSTEMGRAVCONST 	150000.0


#define FUEL_MANEUVER	0.3	/* order.c-- fuel it costs to change aim */
#define DIST_TO_LAND 	10.0 	/* moveship.c,land.c -- 
				   distance ship has to be to land */
/*#define DIST_TO_BURN 50	 /* distance from sun needed to destroy ship */


#define FACTOR_DAMAGE 		2.0
#define FACTOR_DESTPLANET 	0.35

	/* various compiler options that may save cpu time/disk space */
#define NO_SLIDING_SCALE_AUTOMOVE 0	/* move to all four adjacent spots */
#define POPN_MOVE_SCALE_1 400		/* limit at which popn moves to all */
#define POPN_MOVE_SCALE_2 3000		/* " " " popn moves to 2 adj. spaces */
					/* otherwise move to only 1 adj. space*/
#define SHIP_MOVE_SCALE 1.0

#define reg register
 /* to save object code */
#define getchr() fgetc(stdin)
#define putchr(c) fputc((c),stdout)
/* assorted macros */
 /* sign,abs val of number */
#define sgn(x) ( ((x)>=0) ? 1 : -1)
#define abs(x) ( ( (x)<0) ? -(x) : (x) )
#define MIN(x,y) ( ((x)>(y)) ? (y) : (x) )
#define MAX(x,y) ( ((x)<(y)) ? (y) : (x) )
 /* positive modulus */
#define mod(a,b,dum) ((dum)=(a)%(b),abs(dum))
 /* swap two variables */
#define	swap(a, b)  ((a) ^= (b), (b) ^= (a), (a) ^= (b))
 /* euclidean distance */
#define Distsq(x1,y1,x2,y2) ( ((x1)-(x2))*((x1)-(x2)) + ((y1)-(y2))*((y1)-(y2)) )

/* look up sector */
#define Sector(pl,x,y) (Smap[(x) + (y)*(pl).Maxx])
/* adjust temperature to displayed */
#define Temp(x) ((int)(x))

 /* number of AP's to add to each player in ea. system */
 /*   (look in doturn)  */
#define LIMIT_APs 99	/* max # of APs you can have */

#define TYPE_EARTH 	0
#define TYPE_ASTEROID 	1
#define TYPE_AIRLESS 	2
#define TYPE_ICEBALL	3
#define TYPE_GASGIANT 	4
#define TYPE_WATER	5

#define DES_SEA 	0
#define DES_LAND 	1
#define DES_MOUNT 	2
#define DES_GAS 	3
#define DES_ICE		4
#define DES_PLATED 	5

#define MAX_SECT_POPN 999

#define TOXMAX		20	/* max a toxwc can hold */

#define SIGBLOCKS (SIGHUP|SIGTERM|SIGINT|SIGQUIT|SIGSTOP|SIGTSTP)
				/* signals to block... */

#define Bzero(x)  bzero( (char *)&(x), sizeof(x) )
#define Malloc(x) (x *)malloc( sizeof(x) )


#define _STDLIB_H	/* for compiling on NeXt machines */






